# Programme sur le tableau périodique
# Lycée Saint Paul 4 Section Sciences du Numérique groupe ISN : MORENO Pauline - BENSAID Salomé
# Le programme affiche le tableau périodique en interface graphique, un clic souris affiche les détails de l'élément chimique


# Importation des modules tkinter pour l'interface graphique et csv pour la lecture du fichier de données
from tkinter import *
import csv

# Ouverture du fichier de données, copie des données dans une liste (que l'on appelera par la suite "tableau") et fermeture du fichier 
fichierCSV=open("Atomes.csv")
fichier = csv.reader(fichierCSV, delimiter=";")
tableau = [] 
for row in fichier:
    tableau.append(row)
fichierCSV.close()


# Déclaration de la fonction "AffichageDesInformations" qui affiche les détails de l'élément lorsque l'on clique dessus
def AffichageDesInformations(x,colour):
    
    Affichage= "" # Initialisation d'une chaine de caractères vide

    # Définition de la légende
    tableLegende = ["Nom de l'atome : ","Symbole : ","Numéro atomique (Z) : ","Nombre de masse (A) : ","Masse molaire (g/mol) : ","Famille : ","Électrons par couche : ","Année de découverte : ","Découvert par : ","Pays de découverte : ","Couleur :"]

    for i,j in enumerate(tableau[x][:10]): # Affichage de la légende, couplée aux données à afficher récupérées dans "tableau"
        Affichage += tableLegende[i]       # Concatenation de la légende en fin de chaine de caractères "Affichage"
        Affichage += j + "\n"              # Concatenation de la donnée correspondante en fin de chaine de caractères "Affichage"

   #print(Affichage)   -----> affichage test

    fen.topLabel.config(text = Affichage)  # Remplacement du texte du widget "topLabel" par "Affichage"


# Déclaration de la fenêtre graphique principale 
fen = Tk()
fen.title("Tableau periodique des Elements")
fen['bg']='ivory'
xecran = int(fen.winfo_screenheight()) # Récupération de la hauteur écran
yecran = int(fen.winfo_screenwidth())  # Récupération de la largeur écran
fen.geometry('%dx%d%+d%+d' % (yecran,xecran,0,0)) # Définition de la fenêtre en fonction des dimensions de l'écran


# Déclaration d'un cadre conteneur du tableau periodique
espace = Frame(fen)
espace['bg']='ivory'
espace.pack(padx=10, pady=10)

# Déclaration d'un label : texte indiquant à l'utilisateur le fonctionnement du tableau
fen.topLabel = Label(fen, text = "Cliquez sur un élément pour afficher ses informations \n\n\n\n\n\n\n\n\n\n", font="Helvetica 12 italic", pady="1cm")
fen.topLabel['bg']='ivory'
fen.topLabel.pack(before=espace, side=TOP) # Positionnement dans la fenêtre "fen", avant le cadre "espace"


# Création des boutons du tableau
# L'appui sur le bouton appelle la fonction AffichageDesInformations(x,colour), affichant les détails
bou_list=[] # Déclaration d'une liste vide
for item in tableau : 
    
   if (item[5] == "Lanthanides"): # On applique un pady spécifiquement aux Lanthanides pour les séparer du tableau principal
       bou=Button(espace,text=item[1],command=lambda x=int(item[2])-1, colour = item[12]:AffichageDesInformations(x,colour), borderwidth=3, width=4, height=1, bg=item[12])
       abscisse = int(item[10])  # Calcul de l'abscisse de la case 
       bou.grid(row= abscisse ,column=item[11], pady=(10, 0)) # Grid est utilisé pour classer les boutons par rangée et colonne, pady supérieur pour détacher la ligne de la partie haute du tableau
       bou_list.append(bou) # On ajoute le bouton à la liste

   else: # Construction de tous les autres boutons  
       bou=Button(espace,text=item[1],command=lambda x=int(item[2])-1, colour = item[12]:AffichageDesInformations(x,colour), borderwidth=3, width=4, height=1, bg=item[12])
       abscisse = int(item[10])  
       bou.grid(row= abscisse ,column=item[11])
       bou_list.append(bou)

   
# Création séparée des deux boutons n'ayant pas besoin d'afficher d'informations
Button(espace, text='57-71', borderwidth=3, width=4, height=1, background="#CC4452", overrelief="groove", state=DISABLED).grid(row=6, column=2)
Button(espace, text='89-103', borderwidth=3, width=4, height=1, background="#72315C", overrelief="groove", state=DISABLED).grid(row=7, column=2)


# Définition de la fonction effaçant les informations affichées et remettant le texte initial du widget "topLabel"
def reset_text():
    fen.topLabel.config(text="Cliquez sur un élément pour afficher ses informations \n\n\n\n\n\n\n\n\n\n")

# Création du boutton ayant pour fonction reset_text, réinitialisant le message affiché
bouttonEffacer = Button(fen, text="Effacer", command=reset_text, bg='black', fg='white') 
bouttonEffacer.pack(after=espace, side=TOP)


fen.mainloop() # Lancement du gestionnaire d'événements
